<template>
    <div class="row clearfix">
        <div class="col-lg-12 col-md-12">
            <div
                v-if="error"
                class="alert alert-danger alert-dismissible fade show"
                role="alert"
            >
                {{ error }}
                <button
                    type="button"
                    class="close"
                    data-dismiss="alert"
                    aria-label="Close"
                    @click="error = ''"
                >
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div
                v-if="success"
                class="alert alert-success alert-dismissible fade show"
                role="alert"
            >
                {{ success }}
                <button
                    type="button"
                    class="close"
                    data-dismiss="alert"
                    aria-label="Close"
                    @click="success = ''"
                >
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    disabled
                    v-model="user.firstname"
                    type="text"
                    class="form-control"
                    :placeholder="fields.firstname"
                />
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    disabled
                    v-model="user.lastname"
                    type="text"
                    class="form-control"
                    :placeholder="fields.lastname"
                />
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    disabled
                    v-model="user.email"
                    type="text"
                    class="form-control"
                    :placeholder="fields.email"
                />
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    type="date"
                    v-model="info.birthdate"
                    class="form-control"
                    :placeholder="fields.email"
                    :max="pasado"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    v-model="info.dni"
                    type="text"
                    class="form-control"
                    placeholder="#DNI"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    v-model="info.phone"
                    type="text"
                    class="form-control"
                    :placeholder="fields.phone"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <cool-select
                    v-model="gender"
                    :items="genderSelect"
                    item-text="name"
                    :allowMobileScroll="false"
                    :placeholder="fields.gender.title"
                    :inputElCustomAttributes="{ id: 'inputGender' }"
                    :inputForTextClass="'form-control'"
                    :inputStyles="inputStyles"
                    disable-filtering-by-search
                >
                </cool-select>
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    v-model="info.postal_code"
                    type="text"
                    class="form-control"
                    :placeholder="fields.postal_code"
                />
            </div>
        </div>

        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <cool-select
                    v-model="country"
                    :items="countries"
                    item-text="name"
                    :loading="loading"
                    :allowMobileScroll="false"
                    :placeholder="fields.country.title"
                    :inputElCustomAttributes="{ id: 'inputCountry' }"
                    :inputForTextClass="'form-control'"
                    :inputStyles="inputStyles"
                    disable-filtering-by-search
                    @search="onSearchCountry"
                >
                    <template #no-data>
                        {{ noData ? fields.country.msg1 : fields.country.msg2 }}
                    </template>
                    <template #item="{ item }">
                        <div class="item">
                            <div>
                                <span class="item-name"> {{ item.name }} </span>
                            </div>
                        </div>
                    </template>
                    <template v-if="loading" #input-end>
                        <!-- You can use your own loading spinner -->
                        <img
                            height="16px"
                            src="https://i.imgur.com/mTNe6tr.gif"
                            class="loading-indicator"
                        />
                    </template>
                </cool-select>
            </div>
        </div>
        <div v-if="country" class="col-lg-4 col-md-12">
            <div class="form-group">
                <cool-select
                    v-model="state"
                    :items="cities"
                    item-text="name"
                    :loading="loading"
                    :allowMobileScroll="false"
                    :placeholder="fields.city.title"
                    :inputElCustomAttributes="{ id: 'inputCity' }"
                    :inputForTextClass="'form-control'"
                    :inputStyles="inputStyles"
                    disable-filtering-by-search
                    @search="onSearchCity"
                >
                    <template #no-data>
                        {{ noData ? fields.city.msg1 : fields.city.msg2 }}
                    </template>
                    <template #item="{ item }">
                        <div class="item">
                            <div>
                                <span class="item-name"> {{ item.name }} </span>
                            </div>
                        </div>
                    </template>
                    <template v-if="loading" #input-end>
                        <!-- You can use your own loading spinner -->
                        <img
                            height="16px"
                            src="https://i.imgur.com/mTNe6tr.gif"
                            class="loading-indicator"
                        />
                    </template>
                </cool-select>
            </div>
        </div>
        <div class="col-md-12">
            <div class="form-group m-b-10">
                <input
                    v-model="info.address_1"
                    type="text"
                    class="form-control "
                    :placeholder="fields.address_line_1"
                />
            </div>
        </div>
        <div class="col-md-12">
            <div class="form-group m-b-10">
                <input
                    v-model="info.address_2"
                    type="text"
                    class="form-control"
                    :placeholder="fields.address_line_2"
                />
            </div>
        </div>
        <div class="col-md-12">
            <div class="form-group m-b-10">
                <textarea
                    v-model="info.description"
                    rows="4"
                    class="form-control no-resize"
                    :placeholder="fields.description"
                ></textarea>
            </div>
        </div>
        <!-- <div class="col-md-12">
            <div class="checkbox">
                <input id="procheck2" type="checkbox" />
                <label for="procheck2">New task notifications</label>
            </div>
            <div class="checkbox">
                <input id="procheck3" type="checkbox" />
                <label for="procheck3">New friend request notifications</label>
            </div>
        </div> -->
        <div class="col-md-12">
            <button @click.prevent="update()" class="btn btn-primary btn-round">
                Save Changes
            </button>
        </div>
    </div>
</template>

<script>
import { CoolSelect } from "vue-cool-select";
export default {
    components: { CoolSelect },
    props: ["users", "trans"],
    created() {
        this.today;
        this.get();
    },
    mounted() {},
    data() {
        return {
            pasado: this.today(),
            fields: this.trans.edit_info,
            user: this.users,
            info: {
                user_id: "",
                phone: "",
                gender: "",
                postal_code: "",
                country: "",
                ciudad: "",
                address_1: "",
                address_2: "",
                description: "",
                dni:"",
                birthdate: ''
            },
            country: [],
            state: [],
            error: "",
            success: "",
            gender: [],
            genderSelect: [
                { id: 0, name: this.trans.edit_info.gender.male },
                { id: 1, name: this.trans.edit_info.gender.female },
                { id: 2, name: this.trans.edit_info.gender.no_binary }
            ],
            // simple example of items
            countries: [],
            cities: [],
            // there will be a selected item
            selected: null,
            loading: false,
            timeoutId: null,
            noData: false,
            inputStyles: {
                "background-color": "rgba(0,0,0,0)",
                border: "1px solid #E3E3E3",
                "border-radius": "30px",
                color: "#2c2c2c",
                "line-height": "normal",
                "font-size": ".8571em",
                height: "auto",
                "-webkit-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-moz-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-o-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-ms-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                transition:
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-webkit-box-shadow": "none",
                "box-shadow": "none"
            }
        };
    },
    methods: {
        today(){
            let hoy = new Date(Date.now())
            let year = hoy.getFullYear();
            let month = hoy.getMonth() +1;
            if(month < 10){ month = '0'+month}
            let day = hoy.getDate();
            if(day < 10){ day = '0'+day}
            return (year-18)+'-'+day+'-'+month
        },
        async onSearchCountry(search) {
            const lettersLimit = 2;

            this.noData = false;
            if (search.length < lettersLimit) {
                this.countries = [];
                this.loading = false;
                return;
            }
            this.loading = true;

            clearTimeout(this.timeoutId);
            this.timeoutId = setTimeout(async () => {
                const response = await fetch(`/api/data/countries/${search}`);

                this.countries = await response.json();

                this.loading = false;

                if (!this.countries.length) this.noData = true;
            }, 500);
        },
        async onSearchCity(search) {
            const lettersLimit = 2;

            this.noData = false;
            if (search.length < lettersLimit) {
                this.cities = [];
                this.loading = false;
                return;
            }
            this.loading = true;

            clearTimeout(this.timeoutId);
            this.timeoutId = setTimeout(async () => {
                const response = await fetch(
                    `/api/data/states/${this.country.id}/${search}`
                );

                this.cities = await response.json();

                this.loading = false;

                if (!this.cities.length) this.noData = true;
            }, 500);
        },
        update() {
            let url = "/api/users/information/" + this.user.id;
            this.info.country = this.country.id;
            this.info.ciudad = this.state.id;
            this.info.gender = this.gender.id;
            let info = { info: this.info };
            this.user.info = this.info;

            if(
                new Date(this.info.birthdate) > new Date(this.today())
                ){
                this.success = ""
                this.error = "The birthdate is invalid";
                return false
            }

            axios
                .put(url, this.user)
                .then(res => {
                    this.error = "";
                    this.success = res.data.message;
                })
                .catch(err => {
                    this.error = err.response.data.message;
                    this.success = "";
                });
        },
        get() {
            if (this.user.info) {
                this.info.user_id = this.user.info.user_id;
                this.info.country = this.user.info.country;
                this.country.id = this.user.info.country;
                this.info.ciudad = this.user.info.ciudad;
                this.state.id = this.user.info.ciudad;
                this.info.address_1 = this.user.info.address_1;
                this.info.address_2 = this.user.info.address_2;
                this.info.phone = this.user.info.phone;
                this.info.description = this.user.info.description;
                this.info.postal_code = this.user.info.postal_code;
                this.gender.id = this.user.info.gender;
                this.info.dni = this.user.info.dni
                this.info.birthdate = this.user.info.birthdate
            }
        }
    }
};
</script>
<style>
#inputCountry,
#inputCity,
#inputGender {
    padding: 10px 18px 10px 18px !important;
    background-color: rgba(0, 0, 0, 0);
    border: 1px solid #e3e3e3;
    border-radius: 30px;
    color: #2c2c2c;
    line-height: normal;
    font-size: inherit;
    height: auto;
    -webkit-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -moz-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -o-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -ms-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -webkit-box-shadow: none;
    box-shadow: none;
}
</style>
